//+------------------------------------------------------------------+
//|                                                  Tradelevels.mq4 |
//|                                                    Magnus Meseck |
//|                                     magnus.meseck@googlemail.com |
//+------------------------------------------------------------------+
#property copyright "Magnus Meseck"
#property link      "magnus.meseck@googlemail.com"

#property indicator_separate_window
//#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_color2 LightSteelBlue
#property indicator_color3 Green
#property indicator_color4 Gray
#property indicator_color5 Gray

//---- input parameters
extern string ConfigureAMA="The Basic one";
extern int       AMAFast=2;
extern int       AMASlow=4;
extern int       AMARange=5;
extern int       AMAFilter=200;
extern string ConfigureSAMA="The Signal relevant one";
extern int       SAMAFast=2;
extern int       SAMASlow=20;
extern int       SAMARange=2;
extern int       SAMAFilter=100;
extern string ConfigureATR="The Signal line";
extern int       ATRPeriod=14;
extern int       ATRShift=1;
extern double    AccelerationFactor=1.0;
extern string ConfigureWeighting="Weighting between AMA and SAMA";
extern int       AMAWeight=3;
extern string    to="";
extern int       SAMAWeight=1;
extern int       MAonSignals=5;

//---- Buffer Declaration

double   Sellline[];
double   AMA[];
double   Buyline[];
double   Oversold[];
double   Overbought[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- Buffer Number
   IndicatorBuffers(5);

//---- Buffer Initialization
   // Buffer 1
   SetIndexBuffer(0,Sellline);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexEmptyValue(0,0);   
   // Buffer 2
   SetIndexBuffer(1,AMA);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexEmptyValue(1,0);
   // Buffer 3
   SetIndexBuffer(2,Buyline);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexEmptyValue(2,0);
   // Buffer 4
   SetIndexBuffer(3,Oversold);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexEmptyValue(3,0);
   // Buffer 5
   SetIndexBuffer(4,Overbought);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexEmptyValue(4,0);
   // Indicator Name
   IndicatorShortName("Tradelevels");
       
//---- Initialization Complete
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//---- Calculation Preps  
   
   int   limit,i;
   int   counted_bars=IndicatorCounted();
   ArraySetAsSeries(Overbought,true);
   ArraySetAsSeries(Oversold,true);
//---- Checking for Errors
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//----
   for(i=0;i<limit;i++)
      {
      Overbought[i]=(iCustom(NULL,0,"AMA_STL",AMAFast,AMASlow,AMARange,AMAFilter,500,0,i+1)*AMAWeight+iCustom(NULL,0,"AMA_STL",SAMAFast,SAMASlow,SAMARange,SAMAFilter,500,0,i+1)*SAMAWeight)
                  /
                  (SAMAWeight+AMAWeight)
                  +
                  iATR(NULL,0,ATRPeriod,i+ATRShift)*AccelerationFactor;
      }
   for(i=0;i<limit;i++)
      {               
      AMA[i]=iCustom(NULL,0,"AMA_STL",AMAFast,AMASlow,AMARange,AMAFilter,500,0,i+1);
      }
   for(i=0;i<limit;i++)
      {   
      Oversold[i]=(iCustom(NULL,0,"AMA_STL",AMAFast,AMASlow,AMARange,AMAFilter,500,0,i+1)*AMAWeight+iCustom(NULL,0,"AMA_STL",SAMAFast,SAMASlow,SAMARange,SAMAFilter,500,0,i+1)*SAMAWeight)
                  /
                  (SAMAWeight+AMAWeight)
                  -
                  iATR(NULL,0,ATRPeriod,i+ATRShift)*AccelerationFactor; 
      }
   for(i=limit;i>=0;i--)
      {
      Buyline[i]=iMAOnArray(Oversold,0,MAonSignals,0,MODE_LWMA,i);
      }
   for(i=limit;i>=0;i--)
      { 
      Sellline[i]=iMAOnArray(Overbought,0,MAonSignals,0,MODE_LWMA,i);
      }    
   return(0);
  }
//+------------------------------------------------------------------+